Lucene++ - a full-featured, c++ search engine
API Documentation

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes
Lucene::DefaultSkipListWriter Class Reference

Implements the skip list writer for the default posting list format that stores positions and payloads. More...

`#include <DefaultSkipListWriter.h>`

Inheritance diagram for Lucene::DefaultSkipListWriter:

## Public Member Functions

| DefaultSkipListWriter (int32_t skipInterval, int32_t numberOfSkipLevels, int32_t docCount, const IndexOutputPtr &freqOutput, const IndexOutputPtr &proxOutput)
virtual | ~DefaultSkipListWriter ()
virtual String | getClassName ()
boost::shared_ptr< DefaultSkipListWriter > | shared_from_this ()
void | setFreqOutput (const IndexOutputPtr &freqOutput)
void | setProxOutput (const IndexOutputPtr &proxOutput)
void | setSkipData (int32_t doc, bool storePayloads, int32_t payloadLength)
| Sets the values for the current skip data. More...
Public Member Functions inherited from Lucene::MultiLevelSkipListWriter
| MultiLevelSkipListWriter (int32_t skipInterval, int32_t maxSkipLevels, int32_t df)
virtual | ~MultiLevelSkipListWriter ()
boost::shared_ptr< MultiLevelSkipListWriter > | shared_from_this ()
void | bufferSkip (int32_t df)
| Writes the current skip data to the buffers. The current document frequency determines the max level is skip data is to be written to. More...
int64_t | writeSkip (const IndexOutputPtr &output)
| Writes the buffered skip lists to the given output. More...
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Return clone of this object. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal. More...
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects. More...
virtual String | toString ()
| Returns a string representation of the object. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()
Static Public Member Functions inherited from Lucene::MultiLevelSkipListWriter
static String | _getClassName ()

## Protected Member Functions

virtual void | resetSkip ()
virtual void | writeSkipData (int32_t level, const IndexOutputPtr &skipBuffer)
| Subclasses must implement the actual skip data encoding in this method. More...
Protected Member Functions inherited from Lucene::MultiLevelSkipListWriter
void | init ()
Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Protected Attributes

Collection< int32_t > | lastSkipDoc
Collection< int32_t > | lastSkipPayloadLength
Collection< int64_t > | lastSkipFreqPointer
Collection< int64_t > | lastSkipProxPointer
IndexOutputPtr | freqOutput
IndexOutputPtr | proxOutput
int32_t | curDoc
bool | curStorePayloads
int32_t | curPayloadLength
int64_t | curFreqPointer
int64_t | curProxPointer
Protected Attributes inherited from Lucene::MultiLevelSkipListWriter
int32_t | numberOfSkipLevels
| number of levels in this skip list More...
int32_t | skipInterval
| the skip interval in the list with level = 0 More...
Collection< RAMOutputStreamPtr > | skipBuffer
| for every skip level a different buffer is used More...
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Detailed Description

Implements the skip list writer for the default posting list format that stores positions and payloads.

## Constructor & Destructor Documentation

Lucene::DefaultSkipListWriter::DefaultSkipListWriter | ( | int32_t | skipInterval,
|  | int32_t | numberOfSkipLevels,
|  | int32_t | docCount,
|  | const IndexOutputPtr & | freqOutput,
|  | const IndexOutputPtr & | proxOutput
| ) |  |

virtual Lucene::DefaultSkipListWriter::~DefaultSkipListWriter | ( |  | ) |

virtual

## Member Function Documentation

static String Lucene::DefaultSkipListWriter::_getClassName | ( |  | ) |

inline static

virtual String Lucene::DefaultSkipListWriter::getClassName | ( |  | ) |

inline virtual

Reimplemented from Lucene::MultiLevelSkipListWriter.

virtual void Lucene::DefaultSkipListWriter::resetSkip | ( |  | ) |

protected virtual

Reimplemented from Lucene::MultiLevelSkipListWriter.

void Lucene::DefaultSkipListWriter::setFreqOutput | ( | const IndexOutputPtr & | freqOutput | ) |

void Lucene::DefaultSkipListWriter::setProxOutput | ( | const IndexOutputPtr & | proxOutput | ) |

void Lucene::DefaultSkipListWriter::setSkipData | ( | int32_t | doc,
|  | bool | storePayloads,
|  | int32_t | payloadLength
| ) |  |

Sets the values for the current skip data.

boost::shared_ptr< DefaultSkipListWriter > Lucene::DefaultSkipListWriter::shared_from_this | ( |  | ) |

inline

virtual void Lucene::DefaultSkipListWriter::writeSkipData | ( | int32_t | level,
|  | const IndexOutputPtr & | skipBuffer
| ) |  |

protected virtual

Subclasses must implement the actual skip data encoding in this method.

Parameters

  level | the level skip data shall be writing for
  skipBuffer | the skip buffer to write to

Implements Lucene::MultiLevelSkipListWriter.

## Field Documentation

int32_t Lucene::DefaultSkipListWriter::curDoc

protected

int64_t Lucene::DefaultSkipListWriter::curFreqPointer

protected

int32_t Lucene::DefaultSkipListWriter::curPayloadLength

protected

int64_t Lucene::DefaultSkipListWriter::curProxPointer

protected

bool Lucene::DefaultSkipListWriter::curStorePayloads

protected

IndexOutputPtr Lucene::DefaultSkipListWriter::freqOutput

protected

Collection<int32_t> Lucene::DefaultSkipListWriter::lastSkipDoc

protected

Collection<int64_t> Lucene::DefaultSkipListWriter::lastSkipFreqPointer

protected

Collection<int32_t> Lucene::DefaultSkipListWriter::lastSkipPayloadLength

protected

Collection<int64_t> Lucene::DefaultSkipListWriter::lastSkipProxPointer

protected

IndexOutputPtr Lucene::DefaultSkipListWriter::proxOutput

protected

The documentation for this class was generated from the following file:

- DefaultSkipListWriter.h

clucene.sourceforge.net